
{
open Parse
} 

let ws = [' ' '\t' '\n']

rule lexer = parse
  ws+ { lexer lexbuf }
| '(' { LLParen }
| ')' { LRParen }
| ':' { LColon }
| '.' { LDot }
| ',' { LComma }
| '*' { LStar }
| "bool" { LBool }
| "->"   { LArrow }
| "true" { LTrue }
| "false" { LFalse }
| "fn" { LFn }
| "rec"  { LRec }
| "if"   { LIf }
| "then" { LThen }
| "else" { LElse }
| '1' { LOne }
| '2' { LTwo }
| ['a'-'z''A'-'Z']+  { LVar (Lexing.lexeme lexbuf) }
| "||" { LChoice }
| eof { LEof }
