
%{
open Ast
%}

%start program

%type <Ast.exp> exp exp2 program
%type <Ast.typ> typ

%token LLParen LRParen LColon LDot LComma
%token LBool LStar LArrow
%token LTrue LFalse LOne LTwo
%token LFn LRec LIf LThen LElse LChoice
%token LEof
%token <string> LVar

%right LArrow
%%

typ:
  LBool { Bool }
| typ LArrow typ { Arrow($1,$3) }
| LLParen typ LStar typ LRParen { Pair($2,$4) }
| LLParen typ LRParen { $2 }

exp:
  exp2 { $1 }
| exp exp2 { Apply($1,$2) }

exp2:
  LVar   { Var($1) } 
| LTrue  { True}
| LFalse { False }
| LLParen LIf exp LThen exp LElse exp LRParen { If($3,$5,$7) }
| LLParen exp LComma exp LRParen { MakePair($2,$4) }
| LLParen exp LRParen LDot LOne { First($2) }
| LLParen exp LRParen LDot LTwo { Second($2) }
| LLParen LFn  LVar LColon typ LDot exp LRParen { Fun($3,$5,$7) }
| LLParen LRec LVar LColon typ LVar LDot exp LRParen { Rec($3,$5,$6,$8) }
| LLParen exp LRParen { $2 }
| LLParen exp LChoice exp LRParen { failwith "for extra credit" (*Choice ($2,$4)*) }

program:
    exp LEof { $1 }
